﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;
using Syncfusion.Pdf.Tables;
using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace MvcApplication1.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "Modify this template to jump-start your ASP.NET MVC application.";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }

       
        public ActionResult GenerateGrid()
        {
            
            //create the document
            PdfDocument document = new PdfDocument();

            //Add the page
            PdfPage page = document.Pages.Add();

            //Create the table
            PdfLightTable table = new PdfLightTable();

         

            //Load the data
            table.DataSource = DataTable();

            //Handle the row  events 
            table.BeginRowLayout += table_BeginRowLayout;

            //Handle the cell events 
            table.BeginCellLayout += table_BeginCellLayout;

           

            PdfPageTemplateElement header = new PdfPageTemplateElement(new RectangleF(0, 0, page.Graphics.ClientSize.Width, 100));
            
            PdfHTMLTextElement txtlem = new PdfHTMLTextElement();
            txtlem.HTMLText = "<html> <head>Html </head><body><i> Formatted Text</i> in Pdf Document Header</body></html>";
            txtlem.Font = new PdfStandardFont(PdfFontFamily.Courier, 10);
            txtlem.Draw(header.Graphics, header.Bounds);

            header.Graphics.DrawRectangle(PdfPens.Blue, header.Bounds);

            //set the header in document top
            document.Template.Top = header;


            //Draw the table 
            table.Draw(page, new PointF(10, 120));

            // Save and close the document.
            document.Save("Sample.pdf",HttpContext.ApplicationInstance.Response,HttpReadType.Save);

            document.Close(true);

            
            return View();
        }


        private DataTable DataTable()
        {

            DataTable table = new DataTable();

            for (int i = 0; i < 3; i++)
                table.Columns.Add();

            table.Rows.Add(new object[] { " ", " ", " " });
            table.Rows.Add(new object[] { "cell1 ", "Cell2", "cell 3" });
            table.Rows.Add(new object[] { "cell1 ", "Cell2", "cell 3" });
            table.Rows.Add(new object[] { " cell1", "Cell2", "cell 3" });
            table.Rows.Add(new object[] { "cell1 ", "Cell2", "cell 3" });
            table.Rows.Add(new object[] { "cell1 ", "Cell2", "cell 3" });

            return table;
        }

        private void table_BeginCellLayout(object sender, BeginCellLayoutEventArgs args)
        {
            if (args.RowIndex == 0)
            {
                
                // Create the PdfTextElement
                PdfHTMLTextElement txtlem = new PdfHTMLTextElement();
                txtlem.HTMLText = "<html> <head>Html </head><body><i> Formatted Text</i></body></html>";
                txtlem.Font = new PdfStandardFont(PdfFontFamily.Courier, 10);
                txtlem.Draw(args.Graphics, args.Bounds);
            }


        }

        private void table_BeginRowLayout(object sender, BeginRowLayoutEventArgs args)
        {
            //Set the height of the row 
            args.MinimalHeight = 30;

        }

       
    }
}
